package com.logicaldoc.enterprise.webservice;

import com.logicaldoc.enterprise.webservice.DocumentMetadataClient;
import com.logicaldoc.webservice.WSAttribute;
import com.logicaldoc.webservice.auth.AuthClient;
import com.logicaldoc.webservice.document.WSDocument;

public class Main {

	public static String HOST_URL = "http://localhost:8080";
	public static String AUTH_ENDPOINT = HOST_URL +"/services/Auth";
	public static String DOCMETA_ENDPOINT = HOST_URL +"/services/DocumentMetadata";
	
	protected static String Authenticate(String username, String password) throws Exception {
		
		AuthClient authc = new AuthClient(AUTH_ENDPOINT);
	
		// Get session token
		String sid = authc.login(username, password);
		return sid;
	}	
	
	public static void main(String[] args) throws Exception {
		
		String sid = Authenticate("admin", "admin");
		
		DocumentMetadataClient dmc = new DocumentMetadataClient(DOCMETA_ENDPOINT);
		
		long templateID = 15073280L;
		System.out.println(sid);
		WSTemplate template = dmc.getTemplateById(sid, templateID);
		
		WSAttribute[] aaa = template.getAttributes();
		for (int i = 0; i< aaa.length; i++) {
			WSAttribute wsAttribute = aaa[i];
			System.out.println("i: " +i);
			System.out.println(wsAttribute.getName());
			System.out.println(wsAttribute.getType()); // 0 = string
			System.out.println(wsAttribute.getMandatory()); // 1 = mandatory
			System.out.println(wsAttribute.getStringValue()); // preset value will retun a string separated by values eg: supply,services,support,insurance			
		}
		
		// change the value of the preset attribute
		WSAttribute attToChange = aaa[3];
		attToChange.setValue("medicines,services,support,insurance");
		
		long tid = dmc.storeTemplate(sid, template);
		System.out.println(tid);
	}

}
